package com.sos.scheduler.notification.db;

//com.sos.scheduler.history

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

import org.hibernate.annotations.NotFound;
import org.hibernate.annotations.NotFoundAction;

import com.sos.hibernate.classes.DbItem;

/**
 * \class SchedulerOrderStepHistoryDBItem
 * 
 * \brief SchedulerOrderStepHistoryDBItem -
 * 
 * \details
 * 
 * \section SchedulerOrderStepHistoryDBItem.java_intro_sec Introduction
 * 
 * \section SchedulerOrderStepHistoryDBItem.java_samples Some Samples
 * 
 * \code .... code goes here ... \endcode
 * 
 * <p style="text-align:center">
 * <br />
 * --------------------------------------------------------------------------- <br />
 * APL/Software GmbH - Berlin <br />
 * ##### generated by ClaviusXPress (http://www.sos-berlin.com) ######### <br />
 * ---------------------------------------------------------------------------
 * </p>
 * \author Uwe Risse \version 05.10.2011 \see reference
 * 
 * Created on 05.10.2011 11:42:58
 */

@Entity
@Table(name = DBLayerSchedulerMon.TABLE_SCHEDULER_ORDER_STEP_HISTORY)
public class DBItemSchedulerOrderStepHistory extends DbItem implements
		Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private DBCompoundKeySchedulerOrderStepHistory id;

 
	private Long taskId;
	private String state;
	private Date startTime;
	private Date endTime;
	private Boolean error;
	private String errorText;
	private String errorCode;
	private DBItemSchedulerOrderHistory schedulerOrderHistoryDBItem;
	private DBItemSchedulerHistory schedulerHistoryDBItem;
	
	
	public DBItemSchedulerOrderStepHistory() {
	}

	/**
	@ManyToOne
    @JoinTable(name="SCHEDULER_ORDER_HISTORY",
    // joinColumns={@JoinColumn(name="`HISTORY_ID`", referencedColumnName="STEP")})    	    
    joinColumns={@JoinColumn(name="`HISTORY_ID`")},
    inverseJoinColumns={@JoinColumn(name="`STEP`")})
	public SchedulerOrderHistoryDBItem getSchedulerOrderHistoryDBItem() {
		return this.schedulerOrderHistoryDBItem;
	}*/
	
	//@ManyToOne(optional = true,fetch = FetchType.LAZY)
	/**
	@ManyToOne(optional = true)
	@Fetch(FetchMode.JOIN)
	@JoinColumn(name = "`HISTORY_ID`", insertable = false, updatable = false)
	public SchedulerMonOrderHistoryDBItem getSchedulerOrderHistoryDBItem() {
		return this.schedulerOrderHistoryDBItem;
	}*/
	
	
	@ManyToOne(optional = true)
	@NotFound(action=NotFoundAction.IGNORE)
	//@Fetch(FetchMode.JOIN)
	@JoinColumn(name = "`HISTORY_ID`", insertable = false, updatable = false)
	public DBItemSchedulerOrderHistory getSchedulerOrderHistoryDBItem() {
		return this.schedulerOrderHistoryDBItem;
	}
	
	public void setSchedulerOrderHistoryDBItem(
			DBItemSchedulerOrderHistory schedulerOrderHistoryDBItem) {
		this.schedulerOrderHistoryDBItem = schedulerOrderHistoryDBItem;
	}

	@ManyToOne(optional = true)
	//@Fetch(FetchMode.JOIN)
	@NotFound(action=NotFoundAction.IGNORE)
	@JoinColumn(name = "`TASK_ID`", insertable = false, updatable = false)
	public DBItemSchedulerHistory getSchedulerHistoryDBItem() {
		return this.schedulerHistoryDBItem;
	} 
	
	public void setSchedulerHistoryDBItem(
			DBItemSchedulerHistory schedulerHistoryDBItem) {
		this.schedulerHistoryDBItem = schedulerHistoryDBItem;
	}

	
	@Id
	public DBCompoundKeySchedulerOrderStepHistory getId() {
		return id;
	}

	public void setId(DBCompoundKeySchedulerOrderStepHistory id) {
		this.id = id;
	}

	 

	@Column(name = "`TASK_ID`", nullable = false)
	public void setTaskId(Long taskId) {
		this.taskId = taskId;
	}

	@Column(name = "`TASK_ID`", nullable = false)
	public Long getTaskId() {
		return taskId;
	}
	
	@Column(name = "`STATE`", nullable = true)
	public void setState(String state) {
		this.state = state;
	}

	@Column(name = "`STATE`", nullable = true)
	public String getState() {
		return state;
	}

	@Column(name = "`START_TIME`", nullable = false)
	@Temporal(TemporalType.TIMESTAMP)
	public Date getStartTime() {
		return startTime;
	}

	@Column(name = "`START_TIME`", nullable = false)
	@Temporal(TemporalType.TIMESTAMP)
	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}

	@Column(name = "`END_TIME`", nullable = true)
	@Temporal(TemporalType.TIMESTAMP)
	public Date getEndTime() {
		return endTime;
	}

	@Column(name = "`END_TIME`", nullable = true)
	@Temporal(TemporalType.TIMESTAMP)
	public void setEndTime(Date endTime) {
		this.endTime = endTime;
	}

	@Column(name = "`ERROR`", nullable = true)
	public Boolean getError() {
		return error;
	}

	@Column(name = "`ERROR`", nullable = true)
	public void setError(Boolean error) {
		this.error = error;
	}

	@Column(name = "`ERROR_CODE`", nullable = true)
	public String getErrorCode() {
		return errorCode;
	}

	@Column(name = "`ERROR_CODE`", nullable = true)
	public void setErrorCode(String errorCode) {
		this.errorCode = errorCode;
	}

	@Column(name = "`ERROR_TEXT`", nullable = true)
	public String getErrorText() {
		return errorText;
	}

	@Column(name = "`ERROR_TEXT`", nullable = true)
	public void setErrorText(String errorText) {
		this.errorText = errorText;
	}

	@Transient
	public String getStartTimeIso() {
		if (this.getStartTime() == null) {
			return "";
		} else {
			SimpleDateFormat formatter = new SimpleDateFormat(
					"yyyy-MM-dd HH:mm");
			String startTimeIso = formatter.format(this.getStartTime());
			return startTimeIso;
		}
	}

	@Transient
	public String getEndTimeIso() {
		if (this.getEndTime() == null) {
			return "";
		} else {
			SimpleDateFormat formatter = new SimpleDateFormat(
					"yyyy-MM-dd HH:mm");
			String endTimeIso = formatter.format(this.getEndTime());
			return endTimeIso;
		}
	}

	@Transient
	public Long getLogId() {
		return this.getTaskId();
	}

	@Transient
	public String getIdentifier() {
		return getTitle() + getLogId().toString();
	}

}
